#ifndef WSLARRAY_INCL
#define WSLARRAY_INCL

/* The element, will usually be further derived */

class selement {
public:
  virtual ~selement() {};
};

class exp_array
{
#pragma save,call(near_call=>on)
    void init();
    void space();
#pragma restore
  protected:
    selement **head;
    unsigned used;
 private:
    BYTE size;
  public:
#pragma save,call(reg_param=>(bx,es,ax,cx,dx,si,di))
    exp_array();
    ~exp_array();
#pragma save,call(reg_return=>(bx,es)),call(reg_param=>(bx,es,si))
    selement & item(unsigned pos) const           /* Get item at pos         */
               { return *head[pos];}
#pragma restore
//    selement &item(unsigned pos) const;        /* Get item at pos         */
    unsigned ordinality() const { return used; };  /* Return number of items  */
    BOOL is_item(unsigned pos = 0) const;      /* Is there an item at pos     */
    void kill();                               /* Remove all items            */
    void clear();                              /* Remove all items - don't destruct */
    void replace(selement &, unsigned pos, BOOL nodel = 0); /* Replace an item at pos */
    void remove(unsigned pos, BOOL nodel = 0); /* Remove (delete) item at pos */
    void append(selement &);                   /* Adds to end of array        */
    void add(selement &, unsigned pos);        /* Adds at pos                 */
    void swap(unsigned pos1, unsigned pos2);   /* Swap the two elements       */
    unsigned find(const selement *) const;     /* returns position, or -1     */
    BOOL zapall(selement *, BOOL nodel = 0);   /* delete all occurences found */
    BOOL zap(selement *, BOOL nodel = 0);      /* delete if found             */
#pragma restore
};

#endif